//MODELO DE FRENAGEM FINAL COM MODELO N LINEAR VOL VARIAVEL
// 1a PARTE- MODELO NAO LINEAR DAS PRESSOES
clear
funcprot(0)
///PARÂMETROS

BCD = 0.56 // Diametro do tanque de frenagem
SLP = 0.2 // Altura do tanque de frenagem
TPL = 14// Comprimento da linha no trem
BPL = 2 // Comprimento da linha paara o tanque de frenagem
TPD = 0.03 // Diâmetro dos tubos do trem
BPD = 0.03 // Diâmetro dos tubos que vão até os tanques 
AV = 18.325E-6 // Viscosidade do ar
T = 300 // Temperatura de operação
R = 0.287 // Constante do gás perfeito para o ar

Patm = 101 // Pressão atmosférica
PI = 37 + Patm // Pressão inicial
APISTAO = (%pi*(0.56)^2)/4

M=0.5
n=100
Vaux = 0.04926
/// CALCULOS INICIAIS

VBC = BCD^2*%pi/4*SLP+BPD^2*%pi/4*BPL // Volume do tanque de frenagem
VPC = TPD^2*%pi/4*TPL // Volume das linhas do trem
CB = VBC/(R*T) // Capacitância equivalente ao tanque de frenagem
CP = VPC/(R*T) // Capacitância equivalente às linhas do trem

t0 = 0 // Tempo inicial
tf = 180 // Tempo final
dt = 0.001 // Incremento de tempo
t = t0:dt:tf
intv=tf/dt


y=zeros(8,100001)

x1=zeros(1,n)
x1p=zeros(1,n)
x2=zeros(1,n)
x2p=zeros(1,n)
P1=zeros(1,n)
P2=zeros(1,n)
P1_=zeros(1,n)
P2_=zeros(1,n)



function  dy= pistaonlinear(t,y)
    dy1 = y(2)
    dy2 = ((y(5)-PI*(Vaux/(Vaux - (y(1)-0.2)*APISTAO)))*APISTAO)/M - 100*y(1)/M - 50*y(2)/M
    dy3 = y(4)
    dy4 = ((y(6)-PI*(Vaux/(Vaux - (y(3)-0.2)*APISTAO)))*APISTAO)/M - 100*y(3)/M - 50*y(4)/M
    dy5 = ((y(7)-y(5))*(R*T*%pi*(BPD^4)*y(5)/(R*T)))/(APISTAO*y(1)*BPL*128*AV)
    dy6 = ((y(8)-y(6))*(R*T*%pi*(BPD^4)*y(6)/(R*T)))/(APISTAO*y(3)*BPL*128*AV)
    dy7 = ((((Pinicial(t)-y(7))/(128*AV*TPL/(%pi*(TPD^4)*y(7)/(R*T)))) - (((APISTAO*y(3))/(R*T))*(((y(8)-y(6))*(R*T*%pi*(BPD^4)*y(6)/(R*T)))/(APISTAO*y(3)*BPL*128*AV))) - (((APISTAO*y(1))/(R*T))*(((y(7)-y(5))*(R*T*%pi*(BPD^4)*y(5)/(R*T)))/(APISTAO*y(1)*BPL*128*AV))) - ((VPC/(R*T))*((y(7) - y(8) - (128*AV*TPL*APISTAO*y(3)*(((y(8)-y(6))*(R*T*%pi*(BPD^4)*y(6)/(R*T)))/(APISTAO*y(3)*BPL*128*AV))))/(VPC*128*AV*TPL/(%pi*(TPD^4)*y(8))))))/(VPC/(R*T)))
    dy8 = (y(7) - y(8) - (128*AV*TPL*APISTAO*y(3)*(((y(8)-y(6))*(R*T*%pi*(BPD^4)*y(6)/(R*T)))/(APISTAO*y(3)*BPL*128*AV))))/(VPC*128*AV*TPL/(%pi*(TPD^4)*y(8)))
    
    dy=[dy1;dy2;dy3;dy4;dy5;dy6;dy7;dy8]
endfunction

function pressao = Pinicial(t) // Função entrada 
    if t < 0 then
        pressao = PI
    else
        pressao = PI+200
    end
endfunction


y=ode([0.2;0;0.2;0;PI;PI;PI;PI],0,t,pistaonlinear)

x1=y(1,:)
x1p=y(2,:)
x2=y(3,:)
x2p=y(4,:)
P1=y(5,:)
P2=y(6,:)
P1_=y(7,:)
P2_=y(8,:)



//2a PARTE- MODELO DA DESACELERAÇÃO E DO ATRITO



Af=0.073//área de sup da sapata em m2
M=80000*2// massa total do trem em kg 
mi=0.35// coef de atrito
ef=0.56//eficiencia etimoneira 
ra=5.13//razao de alavancas
A=-1000*(Af*mi*ef*ra*(P1+P2))/M// matriz da aceleração 
Al=zeros(intv)
Ateste=-1000*(2*Af*mi*ef*(300))/M
for i= 1:intv
    Al(i)=A(1,i)
end

function y= ace(x,i)// funcao que retorna valores da aceleração
    y= Al(i)
    if x <0 then
        y=0
        
    end
endfunction

function dz=desacelera(t,z)
    z1= z(2)
    z2= ace(z(2),t+1)
    dz = [z1;z2] 
    
endfunction
yo=[0;16.67]
[Y] = ode( yo,t0,t,desacelera)

f2 = scf(1)
plot(t, Y(2,:),"r")
xtitle ("Velocidade de trem com 2 vagôes", "Tempo (s)", "velocidade(m/s)")

f2 = scf(4)
plot(Y(1,:), Y(2,:),"r")
xtitle ("Distancia percorrida por trem até frenagem", "deslocamento (m)", "velocidade(m/s)")

