/// LINEAR - PISTAO - 2CILINDROS
/// MODELO LINEAR VOL VARIAVEL 2 CILINDROS E PISTAO
clear
funcprot(0)
///PARÂMETROS

BCD = 0.56 // Diametro do tanque de frenagem
SLP = 0.2 // Altura do tanque de frenagem
TPL = 14// Comprimento da linha no trem
BPL = 2 // Comprimento da linha paara o tanque de frenagem
TPD = 0.03 // Diâmetro dos tubos do trem
BPD = 0.03 // Diâmetro dos tubos que vão até os tanques 
AV = 18.325E-6 // Viscosidade do ar
T = 300 // Temperatura de operação
R = 0.287 // Constante do gás perfeito para o ar
PRH = 0.00015 // Rugosidade dos tubos
Patm = 101 // Pressão atmosférica
PI = 37 + Patm // Pressão inicial
APISTAO = (%pi*(0.56)^2)/4
M=0.5
n=100
Vaux = 0.04926
K = 100
C = 50
/// CALCULOS INICIAIS

VBC = BCD^2*%pi/4*SLP+BPD^2*%pi/4*BPL // Volume do tanque de frenagem
VPC = TPD^2*%pi/4*TPL // Volume das linhas do trem
CB = VBC/(R*T) // Capacitância equivalente ao tanque de frenagem
CP = VPC/(R*T) // Capacitância equivalente às linhas do trem

t = 0:0.01:100


y=zeros(8,100001)

x1=zeros(1,n)
x1p=zeros(1,n)
x2=zeros(1,n)
x2p=zeros(1,n)
P1=zeros(1,n)
P2=zeros(1,n)
P1_=zeros(1,n)
P2_=zeros(1,n)

y1eq = (616247 - sqrt(114741565009))/(1000000)
y2eq = 0
y3eq = (616247 - sqrt(114741565009))/(1000000)
y4eq = 0
y5eq = PI+200
y6eq = PI+200
y7eq = PI+200
y8eq = PI+200

function  dy= linearizado(t,y)
    dy1 = y(2) 
    dy2 = -(K/M)*(y(1) - y1eq) - ((PI*Vaux*(APISTAO^2))/(M*(Vaux + APISTAO*(0.2 - y1eq))^2))*(y(1)-y1eq) -(C/M)*(y(2) - y2eq) + (APISTAO/M)*(y(5) - y5eq)
    dy3 = y(4)
    dy4 = -(K/M)*(y(3) - y3eq) - ((PI*Vaux*(APISTAO^2))/(M*(Vaux + APISTAO*(0.2 - y3eq))^2))*(y(3)-y3eq) -(C/M)*(y(4) - y4eq) + (APISTAO/M)*(y(6) - y6eq)
    dy5 = (((y7eq - 2*y5eq)*(%pi*BPD^4))/(APISTAO*y1eq*BPL*128*AV))*(y(5) - y5eq) + ((y5eq*%pi*BPD^4)/(APISTAO*y1eq*BPL*128*AV))*(y(7) - y7eq)
    dy6 = (((y8eq - 2*y6eq)*(%pi*BPD^4))/(APISTAO*y3eq*BPL*128*AV))*(y(6) - y6eq) + ((y6eq*%pi*BPD^4)/(APISTAO*y3eq*BPL*128*AV))*(y(8) - y8eq)
    dy7 = -(((y7eq - 2*y5eq)*(%pi*BPD^4))/(BPL*128*AV*VPC))*(y(5) - y5eq) + (((DEGRAU(t) - 2*y7eq)*(%pi*BPD^4))/(128*AV*TPL*VPC))*(y(7) - y7eq) - ((y5eq*%pi*BPD^4)/(BPL*128*AV*VPC))*(y(7) - y7eq) - ((y8eq*%pi*BPD^4)/(128*AV*TPL*VPC))*(y(7) - y7eq) -(((y7eq - 2*y8eq)*(%pi*BPD^4))/(128*AV*TPL*VPC))*(y(8) - y8eq) + ((DEGRAU(t)-338)*y7eq*%pi*(BPD^4))/(128*AV*TPL*VPC)
    dy8 = -(((%pi*BPD^4)*(y8eq - 2*y6eq))/(VPC*BPL*128*AV))*(y(6) - y6eq) + ((y8eq*%pi*BPD^4)/(128*AV*TPL*VPC))*(y(7)-y7eq) + (((y7eq - 2*y8eq)*(%pi*BPD^4))/(128*AV*TPL*VPC))*(y(8) - y8eq) - ((y6eq*%pi*BPD^4)/(VPC*BPL*128*AV))*(y(8)-y8eq)
    
    dy=[dy1;dy2;dy3;dy4;dy5;dy6;dy7;dy8]
endfunction

function pressao = DEGRAU(t) // Função entrada 
    if t < 0 then
        pressao = PI
    else
        pressao = PI+200
    end
endfunction


y=ode([0.2;0;0.2;0;PI;PI;PI;PI],0,t,linearizado)

x1=y(1,:)
x1p=y(2,:)
x2=y(3,:)
x2p=y(4,:)
P1=y(5,:)
P2=y(6,:)
P1_=y(7,:)
P2_=y(8,:)



f1 = scf(1)
plot(t, P1,"m")
plot(t, P2,)
legend(["P1" ; "P2"]) ;
xtitle ("Pressões nos reservatórios de número 1 e 2 em função do tempo (Modelo linear)", "Tempo (s)", "Pressão (kPa)")
f2 = scf(2)
plot(t,x1, "m")
plot(t,x2)
legend(["x1" ; "x2"]) ;
xtitle ("Deslocamentos dos pistôes 1 e 2 em função do tempo (Modelo linear)", "Tempo (s)", "Deslocamento(m)")
