// MODELO COM MATRIZ DE TRANSIÇÃO 

BCD = 0.56 // Diametro do tanque de frenagem
SLP = 0.2 // Altura do tanque de frenagem
TPL = 14// Comprimento da linha no trem
BPL = 2 // Comprimento da linha paara o tanque de frenagem
TPD = 0.03 // Diâmetro dos tubos do trem
BPD = 0.03 // Diâmetro dos tubos que vão até os tanques 
AV = 18.325E-6 // Viscosidade do ar
T = 300 // Temperatura de operação
R = 0.287 // Constante do gás perfeito para o ar
PRH = 0.00015 // Rugosidade dos tubos
Patm = 101 // Pressão atmosférica
PI = 37 + Patm // Pressão inicial
APISTAO = (%pi*(0.56)^2)/4
P0i = PI
M=0.5
n=100
Vaux = 0.04926
P0 = PI+200
K = 100
C = 50
/// CALCULOS INICIAIS

VBC = BCD^2*%pi/4*SLP+BPD^2*%pi/4*BPL // Volume do tanque de frenagem
VPC = TPD^2*%pi/4*TPL // Volume das linhas do trem
CB = VBC/(R*T) // Capacitância equivalente ao tanque de frenagem
CP = VPC/(R*T) // Capacitância equivalente às linhas do trem

y1eq = (616247 - sqrt(114741565009))/(1000000)
y2eq = 0
y3eq = (616247 - sqrt(114741565009))/(1000000)
y4eq = 0
y5eq = PI+200
y6eq = PI+200
y7eq = PI+200
y8eq = PI+200


K1 = (-(K/M)-((PI*Vaux*(APISTAO^2))/(M*(Vaux + APISTAO*(0.2 - y1eq))^2)))
K2 = -C/M
K3 = APISTAO/M
K4 = (-(K/M) -((PI*Vaux*(APISTAO^2))/(M*(Vaux + APISTAO*(0.2 - y3eq))^2)))
K5 = (((y7eq - 2*y5eq)*(%pi*BPD^4))/(APISTAO*y1eq*BPL*128*AV))
K6 = ((y5eq*%pi*BPD^4)/(APISTAO*y1eq*BPL*128*AV))
K7 = (((y8eq - 2*y6eq)*(%pi*BPD^4))/(APISTAO*y3eq*BPL*128*AV))
K8 = ((y6eq*%pi*BPD^4)/(APISTAO*y3eq*BPL*128*AV))
K9 = (-(((y7eq - 2*y5eq)*(%pi*BPD^4))/(BPL*128*AV*VPC)))
K10 = (((338 - 2*y7eq)*(%pi*BPD^4))/(128*AV*TPL*VPC) - ((y5eq*%pi*BPD^4)/(BPL*128*AV*VPC)) - ((y8eq*%pi*BPD^4)/(128*AV*TPL*VPC)))
K11 = (-(((y7eq - 2*y8eq)*(%pi*BPD^4))/(128*AV*TPL*VPC)))
K12 = (-(((%pi*BPD^4)*(y8eq - 2*y6eq))/(VPC*BPL*128*AV)))
K13 = ((y8eq*%pi*BPD^4)/(128*AV*TPL*VPC))
K14 = ((((y7eq - 2*y8eq)*(%pi*BPD^4))/(128*AV*TPL*VPC))-((y6eq*%pi*BPD^4)/(VPC*BPL*128*AV)))
K15 = ((y7eq*%pi*(BPD^4))/(128*AV*TPL*VPC))

A = [0,1,0,0,0,0,0,0;...
    K1,K2,0,0,K3,0,0,0;...
    0,0,0,1,0,0,0,0;...
    0,0,K4,K2,0,K3,0,0;...
    0,0,0,0,K5,0,K6,0;...
    0,0,0,0,0,K7,0,K8;...
    0,0,0,0,K9,0,K10,K11;...
    0,0,0,0,0,K12,K13,K14]

B = [0;...
    0;...
    0;...
    0;...
    0;...
    0;...
    K15;...
    0]

C = [1 0 0 0 0 0 0 0;0 0 1 0 0 0 0 0]

D = [0;0]

t0 = 0 // Tempo inicial
tf = 100 // Tempo final
dt = 0.01 // Incremento de tempo
t = t0:dt:tf
N=tf/dt
n=100
fi=0
gama=0
Patm = 101 // Pressão atmosférica
PI = 37 + Patm // Pressão inicial
x0=[[0.2;0;0.2;0;PI;PI;PI;PI]; ]
xfin=zeros(8,N)
yfin=zeros(2,N)
for i=0:n
    fi=fi+(A^i)*(dt^i)/factorial(i)
    gama=gama+(dt*(A^i)*(dt^i)/factorial(i+1))
end

u_aux=PI+200

for i=1:N+1 
    xi=fi*x0+gama*B*u_aux
    yi=C*xi
    xfin(:,i)=xi
    yfin(:,i)=yi
    x0=xi
end

f1 = scf(1)
plot(t, xfin(5,:),"r")
plot(t, xfin(6,:),"g")
legend(["p1" ; "p2"]) ;
xtitle ("Pressões nos reservatórios 1 e 2 em função do tempo", "Tempo (s)", "Pressão(kPa)")

f2 = scf(2)
plot(t, xfin(1,:)+0.12,"r")
plot(t, xfin(3,:)+0.12,"g")
legend(["x1" ; "x2"]) ;
xtitle ("Deslocamento nos reservatórios 1 e 2  em função do tempo", "Tempo (s)", "deslocamento(m)")


